"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DataRenderer = exports.ChoiceRenderer = exports.DocumentRenderer = exports.ValueRenderer = exports.PropertyRenderer = exports.TypeRenderer = exports.IDRenderer = exports.ObjectRenderer = exports.FancyPageHeader = exports.FancyRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var styles = {
  fancyPage: {},
  fancyPageHeader: {}
};

var FancyRenderer = function FancyRenderer(frame, mode, view) {
  return /*#__PURE__*/_react["default"].createElement("span", {
    style: styles.fancyPage
  }, /*#__PURE__*/_react["default"].createElement(FancyPageHeader, {
    frame: frame,
    mode: mode,
    view: view
  }), /*#__PURE__*/_react["default"].createElement(ObjectRenderer, {
    frame: frame,
    mode: mode,
    view: view
  }));
};

exports.FancyRenderer = FancyRenderer;

var FancyPageHeader = function FancyPageHeader(_ref) {
  var frame = _ref.frame,
      mode = _ref.mode,
      view = _ref.view;
  return /*#__PURE__*/_react["default"].createElement("span", {
    style: styles.fancyPageHeader
  }, "Page Header");
};

exports.FancyPageHeader = FancyPageHeader;

var ObjectRenderer = function ObjectRenderer(_ref2) {
  var frame = _ref2.frame,
      mode = _ref2.mode,
      view = _ref2.view;

  var _useState = (0, _react.useState)(1),
      _useState2 = _slicedToArray(_useState, 2),
      redraw = _useState2[0],
      setRedraw = _useState2[1];

  var _useState3 = (0, _react.useState)(frame.subject()),
      _useState4 = _slicedToArray(_useState3, 2),
      oid = _useState4[0],
      setOid = _useState4[1];

  var _useState5 = (0, _react.useState)(frame.subjectClass()),
      _useState6 = _slicedToArray(_useState5, 2),
      otype = _useState6[0],
      setOtype = _useState6[1];

  if (!frame) return null;
  var showid = false;
  var showtype = false;

  var onAddProp = function onAddProp(e) {
    frame.addProperty(e.value);
    setRedraw(redraw + 1);
  };

  var getMissingPropertySelector = function getMissingPropertySelector() {
    var mpl = frame.getMissingPropertyList();

    if (Object.keys(mpl).length) {
      return /*#__PURE__*/_react["default"].createElement(Select, {
        onChange: onAddProp,
        options: mpl,
        placeholder: "Add Property"
      });
    }

    return null;
  };

  var updateID = function updateID(nid) {
    frame.subjid = nid;
    setOid(nid);
  };

  var updateType = function updateType(ntype) {
    frame.cls = ntype;
    setOtype(ntype);
  };

  var renderProperties = function renderProperties() {
    var props = [];

    for (var p in frame.properties) {
      var vframe = frame.properties[p];
      if (Array.isArray(vframe)) vframe = vframe[0];
      props = props.concat( /*#__PURE__*/_react["default"].createElement(PropertyRenderer, {
        view: view,
        key: p + "_property",
        frame: vframe,
        mode: mode
      }));
    }

    return props;
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", null, mode != "edit" && /*#__PURE__*/_react["default"].createElement("th", {
    colSpan: "2",
    style: headerstyle,
    title: frame.subject()
  }, frame.subjectClass()), mode == "edit" && /*#__PURE__*/_react["default"].createElement("th", {
    colSpan: "3",
    style: headerstyle
  }, /*#__PURE__*/_react["default"].createElement(Row, null, /*#__PURE__*/_react["default"].createElement(Col, {
    title: frame.subject()
  }, frame.subjectClass()), /*#__PURE__*/_react["default"].createElement(Col, null, getMissingPropertySelector()))), "                                   ")), /*#__PURE__*/_react["default"].createElement("tbody", null, showid && /*#__PURE__*/_react["default"].createElement(IDRenderer, {
    id: oid,
    mode: mode,
    view: view,
    update: updateID
  }), showtype && /*#__PURE__*/_react["default"].createElement(TypeRenderer, {
    type: otype,
    mode: mode,
    view: view,
    update: updateType
  }), renderProperties()));
};

exports.ObjectRenderer = ObjectRenderer;

var IDRenderer = function IDRenderer(_ref3) {
  var id = _ref3.id,
      mode = _ref3.mode,
      view = _ref3.view,
      update = _ref3.update;

  var onc = function onc(e) {
    update(e.target.value);
  };

  return /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    style: labelstyle
  }, "ID"), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", null), /*#__PURE__*/_react["default"].createElement("td", {
    style: valuestyle
  }, mode != "edit" && /*#__PURE__*/_react["default"].createElement("span", null, TerminusClient.UTILS.shorten(id)), mode == "edit" && /*#__PURE__*/_react["default"].createElement(Row, null, /*#__PURE__*/_react["default"].createElement(Col, null, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: TerminusClient.UTILS.shorten(id),
    onChange: onc
  })), /*#__PURE__*/_react["default"].createElement(Col, null))));
};

exports.IDRenderer = IDRenderer;

var TypeRenderer = function TypeRenderer(_ref4) {
  var type = _ref4.type,
      mode = _ref4.mode,
      view = _ref4.view,
      update = _ref4.update;

  var onc = function onc(e) {
    update(e.target.value);
  };

  return /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    style: labelstyle
  }, "Type"), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", null), /*#__PURE__*/_react["default"].createElement("td", {
    style: valuestyle
  }, mode != "edit" && /*#__PURE__*/_react["default"].createElement("span", null, TerminusClient.UTILS.shorten(type)), mode == "edit" && /*#__PURE__*/_react["default"].createElement(Row, null, /*#__PURE__*/_react["default"].createElement(Col, null, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: TerminusClient.UTILS.shorten(type),
    onChange: onc
  })), /*#__PURE__*/_react["default"].createElement(Col, null))));
};

exports.TypeRenderer = TypeRenderer;

var PropertyRenderer = function PropertyRenderer(_ref5) {
  var frame = _ref5.frame,
      mode = _ref5.mode,
      view = _ref5.view;
  if (!frame) return null;

  var _useState7 = (0, _react.useState)(1),
      _useState8 = _slicedToArray(_useState7, 2),
      redraw = _useState8[0],
      setRedraw = _useState8[1];

  var _useState9 = (0, _react.useState)(),
      _useState10 = _slicedToArray(_useState9, 2),
      rvals = _useState10[0],
      setRvals = _useState10[1];

  var delstyle = {
    padding: "4px"
  };
  (0, _react.useEffect)(function () {
    return setRvals(getPvals());
  }, [frame, mode]);

  if (!frame.getLabel) {
    console.log("strange frame", frame);
    return null;
  }

  function addValue() {
    frame.addValueFrame(frame.createEmpty());
    setRvals(getPvals());
    setRedraw(redraw + 1);
  }

  var deleteValue = function deleteValue(val, index) {
    frame.removeValue(val);
    setRvals(getPvals());
    setRedraw(redraw + 1);
  };

  function getLabelPart(len) {
    return /*#__PURE__*/_react["default"].createElement("td", {
      key: frame.predicate + "_label",
      style: labelstyle,
      rowSpan: len
    }, mode == "edit" && /*#__PURE__*/_react["default"].createElement("button", {
      onClick: addValue
    }, "+"), frame.getLabel());
  }

  function getPvals() {
    var vals = [];

    var isDup = function isDup(val) {
      if (vals.indexOf(val) == -1) {
        vals.push(val);
        return false;
      }

      return true;
    };

    var rvals = [];

    for (var i = 0; i < frame.values.length; i++) {
      if (!isDup(frame.values[i].get())) {
        rvals.push(frame.values[i]);
      }
    }

    return rvals;
  }

  function getDelVal(index, vframe) {
    var g = vframe.get();

    var f = function f() {
      deleteValue(g, index);
    };

    return f;
  }

  if (!rvals || !rvals.length) return null;
  var rows = [];

  for (var i = 0; i < rvals.length; i++) {
    if (i == 0) {
      rows.push( /*#__PURE__*/_react["default"].createElement("tr", {
        key: frame.predicate + "_" + i
      }, getLabelPart(rvals.length), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", {
        style: delstyle
      }, /*#__PURE__*/_react["default"].createElement("button", {
        onClick: getDelVal(i, rvals[i])
      }, "-"), " "), /*#__PURE__*/_react["default"].createElement("td", {
        key: frame.predicate + "_value_" + i,
        style: valuestyle
      }, /*#__PURE__*/_react["default"].createElement(ValueRenderer, {
        redraw: redraw,
        frame: rvals[i],
        mode: mode,
        view: view
      }))));
    } else {
      rows.push( /*#__PURE__*/_react["default"].createElement("tr", {
        key: frame.predicate + "_" + i
      }, mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", {
        style: delstyle
      }, /*#__PURE__*/_react["default"].createElement("button", {
        onClick: getDelVal(i, rvals[i])
      }, "-")), /*#__PURE__*/_react["default"].createElement("td", {
        style: valuestyle
      }, /*#__PURE__*/_react["default"].createElement(ValueRenderer, {
        redraw: redraw,
        frame: rvals[i],
        mode: mode,
        view: view
      }))));
    }
  }

  return rows;
};

exports.PropertyRenderer = PropertyRenderer;

var ValueRenderer = function ValueRenderer(_ref6) {
  var frame = _ref6.frame,
      mode = _ref6.mode,
      view = _ref6.view,
      redraw = _ref6.redraw;

  var _useState11 = (0, _react.useState)(""),
      _useState12 = _slicedToArray(_useState11, 2),
      v = _useState12[0],
      setV = _useState12[1];

  (0, _react.useEffect)(function () {
    return setV(frame.get());
  }, [redraw, frame]);

  var updval = function updval(vv) {
    setV(vv);
    frame.set(vv);
  };

  if (!frame.isData()) {
    return TableRenderer(frame, mode);
  } else if (frame.isChoice()) {
    return /*#__PURE__*/_react["default"].createElement(ChoiceRenderer, {
      val: v,
      frame: frame,
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else if (frame.isDocument()) {
    return /*#__PURE__*/_react["default"].createElement(DocumentRenderer, {
      val: v,
      frame: frame,
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else if (frame.isData()) {
    return /*#__PURE__*/_react["default"].createElement(DataRenderer, {
      val: v,
      type: frame.getType(),
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else {
    alert("Frame has no known type");
    console.log(frame);
  }
};

exports.ValueRenderer = ValueRenderer;

var DocumentRenderer = function DocumentRenderer(_ref7) {
  var val = _ref7.val,
      mode = _ref7.mode,
      frame = _ref7.frame,
      updateVal = _ref7.updateVal,
      view = _ref7.view;

  if (mode == "edit") {
    return /*#__PURE__*/_react["default"].createElement(DataRenderer, {
      val: val,
      mode: mode,
      type: frame.getType(),
      updateVal: updateVal
    });
  } else {
    var ds = function ds() {
      if (view.selectDocument) view.selectDocument(val);
    };

    var lstyle = {
      cursor: "pointer"
    };
    return /*#__PURE__*/_react["default"].createElement(Row, null, /*#__PURE__*/_react["default"].createElement(Col, null, /*#__PURE__*/_react["default"].createElement("span", {
      style: lstyle,
      onClick: ds
    }, val)), /*#__PURE__*/_react["default"].createElement(Col, null));
  }
};

exports.DocumentRenderer = DocumentRenderer;

var ChoiceRenderer = function ChoiceRenderer(_ref8) {
  var val = _ref8.val,
      mode = _ref8.mode,
      frame = _ref8.frame,
      updateVal = _ref8.updateVal;

  if (mode == "edit") {
    var lab = val || "Select from choices";
    var opts = frame.frame.elements.map(function (item) {
      if (TerminusClient.UTILS.compareIDs(item["class"], val)) {
        lab = item.label["@value"];
      }

      return {
        value: TerminusClient.UTILS.shorten(item["class"]),
        label: item.label["@value"]
      };
    });

    var onChange = function onChange(e) {
      updateVal(e.value);
    };

    return /*#__PURE__*/_react["default"].createElement(Row, null, /*#__PURE__*/_react["default"].createElement(Col, null, /*#__PURE__*/_react["default"].createElement(Select, {
      defaultValue: val,
      isClearable: true,
      onChange: onChange,
      options: opts,
      placeholder: lab
    })), /*#__PURE__*/_react["default"].createElement(Col, null));
  } else {
    var tit = val;
    var _lab = val;
    frame.frame.elements.map(function (item) {
      if (TerminusClient.UTILS.compareIDs(item["class"], val)) {
        tit = val + " - " + item.comment["@value"];
        _lab = item.label["@value"];
      }
    });
    return /*#__PURE__*/_react["default"].createElement("span", {
      title: tit
    }, _lab);
  }
};

exports.ChoiceRenderer = ChoiceRenderer;

var DataRenderer = function DataRenderer(_ref9) {
  var val = _ref9.val,
      mode = _ref9.mode,
      type = _ref9.type,
      updateVal = _ref9.updateVal;

  if (mode == "edit") {
    var onc = function onc(e) {
      updateVal(e.target.value);
    };

    var mv = val ? "" + val : "";
    return /*#__PURE__*/_react["default"].createElement(Row, null, /*#__PURE__*/_react["default"].createElement(Col, null, /*#__PURE__*/_react["default"].createElement("input", {
      type: "text",
      value: mv,
      onChange: onc
    })), /*#__PURE__*/_react["default"].createElement(Col, null, TerminusClient.UTILS.shorten(type)));
  } else {
    return val;
  }
};

exports.DataRenderer = DataRenderer;