"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FrameViewer = FrameViewer;

var _react = _interopRequireWildcard(require("react"));

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _TableRenderer = require("./TableRenderer");

var _FancyRenderer = require("./FancyRenderer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function FrameViewer(classframe, doc, view, edit, client) {
  var _this = this;

  this.frame = view.create(client);
  this.mode = edit ? "edit" : "view";

  if (classframe && classframe['system:properties']) {
    if (doc) {
      this.frame.load(classframe['system:properties'], doc);
    } else {
      this.frame.loadSchemaFrames(classframe['system:properties']);
    }
  } else {
    alert("No frames");
    console.log(classframe);
  }

  var getRenderer = function getRenderer(name, frame, args) {
    var f = function f() {
      if (name == "fancy") {
        return (0, _FancyRenderer.FancyRenderer)(frame, _this.mode, view);
      }

      return (0, _TableRenderer.TableRenderer)(frame, _this.mode, view);
    };

    return f;
  };

  this.frame.filterFrame(getRenderer);
  return this;
}

FrameViewer.prototype.render = function () {
  return this.frame.document.render();
};

FrameViewer.prototype.extract = function () {
  return this.frame.document.extract();
};