"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SchemaBuilder = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactSizeme = require("react-sizeme");

var _reactSplitPane = _interopRequireDefault(require("react-split-pane"));

var _elementsName = require("./utils/elementsName");

var _ModelTreeComponent = require("./ModelTreeComponent");

var _DetailsModelComponent = require("./detailsComponent/DetailsModelComponent");

var _NodeConstants = require("./node/NodeConstants");

var _graphObjectContext = require("./hook/graphObjectContext");

var _detailsLabels = require("../constants/details-labels");

var _ModelMainHeaderComponent = require("./detailsComponent/ModelMainHeaderComponent");

var _InfoBoxComponent = require("./detailsComponent/InfoBoxComponent");

var _ObjectClassModelViewMode = require("./detailsComponent/viewMode/ObjectClassModelViewMode");

var _InfoObjectComponent = require("./detailsComponent/InfoObjectComponent");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var SchemaBuilder = function SchemaBuilder(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      graphDataProvider = _GraphContextObj.graphDataProvider,
      setNodeAction = _GraphContextObj.setNodeAction,
      graphUpdateLabel = _GraphContextObj.graphUpdateLabel,
      selectedNodeObject = _GraphContextObj.selectedNodeObject,
      changeCurrentNode = _GraphContextObj.changeCurrentNode,
      nodePropertiesList = _GraphContextObj.nodePropertiesList,
      objectPropertyToRange = _GraphContextObj.objectPropertyToRange,
      updateValue = _GraphContextObj.updateValue,
      addNewProperty = _GraphContextObj.addNewProperty,
      removeElement = _GraphContextObj.removeElement,
      objectPropertyList = _GraphContextObj.objectPropertyList,
      objPropsRelatedToClass = _GraphContextObj.objPropsRelatedToClass,
      savedObjectToWOQL = _GraphContextObj.savedObjectToWOQL,
      updateChoices = _GraphContextObj.updateChoices,
      isFocusOnNode = _GraphContextObj.isFocusOnNode;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isEditMode = _useState2[0],
      setIsEditMode = _useState2[1];

  var _useState3 = (0, _react.useState)(true),
      _useState4 = _slicedToArray(_useState3, 2),
      panelIsOpen = _useState4[0],
      setOpenClosePanel = _useState4[1];

  var _useState5 = (0, _react.useState)(undefined),
      _useState6 = _slicedToArray(_useState5, 2),
      zoomEvent = _useState6[0],
      setZoomEvent = _useState6[1];

  var saveData = function saveData() {
    var query = savedObjectToWOQL();
    if (props.saveGraph) props.saveGraph(query);
  };
  /*
  * Edit mode when model is empty, so it has only the group type
  */


  (0, _react.useEffect)(function () {
    //startDataProsition();      
    if (graphDataProvider && graphDataProvider.size === 4) {
      setIsEditMode(true);
    } //else{
    //setIsEditMode(false);
    //}

  }, [graphDataProvider]); //const panelIsOpen=props.panelIsOpen || true;

  var mainPanelSize = panelIsOpen ? "calc(100% - 450px)" : "100%";
  var treeMainGraphObj = props.treeMainGraphObj;
  var showInfoComp = false;

  if (!selectedNodeObject || !selectedNodeObject.name || selectedNodeObject.type === _elementsName.CLASS_TYPE_NAME.SCHEMA_ROOT || selectedNodeObject.type === _elementsName.CLASS_TYPE_NAME.SCHEMA_GROUP) {
    showInfoComp = true;
  }

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__header"
  }, /*#__PURE__*/_react["default"].createElement(_ModelMainHeaderComponent.ModelMainHeaderComponent, {
    panelIsOpen: panelIsOpen,
    openClosePanel: setOpenClosePanel,
    setNodeAction: setNodeAction,
    extraTools: props.extraTools,
    setZoomEvent: setZoomEvent,
    saveData: saveData,
    changeMode: setIsEditMode,
    isEditMode: isEditMode
  })), /*#__PURE__*/_react["default"].createElement(_reactSplitPane["default"], {
    className: "tdb_panel_split",
    split: "vertical",
    minSize: 400,
    size: mainPanelSize
  }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactSizeme.SizeMe, {
    monitorHeight: true
  }, function (_ref) {
    var size = _ref.size;
    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        minHeight: "400px",
        height: "calc(100vh - 10px)"
      }
    }, graphDataProvider && /*#__PURE__*/_react["default"].createElement(_ModelTreeComponent.ModelTreeComponent, {
      objectPropertyToRange: objectPropertyToRange,
      zoomEvent: zoomEvent,
      isEditMode: isEditMode,
      setNodeAction: setNodeAction,
      selectedNodeObject: selectedNodeObject,
      changeCurrentNode: changeCurrentNode,
      width: size.width,
      height: size.height,
      addedNewNode: selectedNodeObject.newNode,
      graphUpdateLabel: graphUpdateLabel,
      graphDataProvider: graphDataProvider,
      isFocusOnNode: isFocusOnNode
    }));
  })), showInfoComp && selectedNodeObject.type !== _elementsName.CLASS_TYPE_NAME.SCHEMA_GROUP && /*#__PURE__*/_react["default"].createElement(_InfoBoxComponent.InfoBoxComponent, {
    dbName: props.dbName
  }), showInfoComp && selectedNodeObject.type === _elementsName.CLASS_TYPE_NAME.SCHEMA_GROUP && /*#__PURE__*/_react["default"].createElement(_InfoObjectComponent.InfoObjectComponent, {
    panelType: selectedNodeObject.name
  }), !showInfoComp && isEditMode === false && /*#__PURE__*/_react["default"].createElement(_ObjectClassModelViewMode.ObjectClassModelViewMode, null), !showInfoComp && /*#__PURE__*/_react["default"].createElement(_DetailsModelComponent.DetailsModelComponent, {
    updateChoices: updateChoices,
    objPropsRelatedToClass: objPropsRelatedToClass,
    objectPropertyList: objectPropertyList,
    removeElement: removeElement,
    addNewProperty: addNewProperty,
    nodePropertiesList: nodePropertiesList,
    currentNodeJson: selectedNodeObject,
    updateValue: updateValue
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__footer"
  }));
};

exports.SchemaBuilder = SchemaBuilder;