"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BasePropertyComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _BaseElement = require("./BaseElement");

var _Accordion = require("../../form/Accordion");

var _detailsLabels = require("../../constants/details-labels");

var _BaseSelectComponent = require("./BaseSelectComponent");

var _BaseNumericInput = require("./BaseNumericInput");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _HelpComponent = require("./HelpComponent");

var _BaseInputElement = require("./BaseInputElement");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BasePropertyComponent = function BasePropertyComponent(props) {
  var currentNodeJson = props.currentNodeJson || {};
  var title = currentNodeJson.label || currentNodeJson.id;
  var viewBaseSchema = props.viewBaseSchema === false ? false : true;
  var showAllButton = props.showAllButton || {};
  var leftIconClassName = _detailsLabels.GET_ICON_NAME[currentNodeJson.type] || "custom-img-string";

  var changePropertyValue = function changePropertyValue(propName, propValue) {
    if (propName === 'label') {
      title = propValue;
    }

    props.updateValue(propName, propValue, currentNodeJson);
  };

  return /*#__PURE__*/_react["default"].createElement(_Accordion.Accordion, {
    showBody: props.showBody,
    arrowOpenClassName: "accordion__arrow fa fa-caret-up",
    arrowCloseClassName: "accordion__arrow fa fa-caret-down",
    title: title,
    leftIconClassName: leftIconClassName,
    tooltip: currentNodeJson.type || ''
  }, viewBaseSchema && /*#__PURE__*/_react["default"].createElement(_BaseElement.BaseElement, {
    updateValue: changePropertyValue,
    removeElement: props.removeElement,
    nodeJsonData: currentNodeJson,
    showAllButton: showAllButton,
    isNodeObject: false
  }, props.selectDataProvider && /*#__PURE__*/_react["default"].createElement(_BaseSelectComponent.BaseSelectComponent, {
    help: props.help,
    optionChange: changePropertyValue,
    title: props.selectDataProvider.label,
    dataProvider: props.selectDataProvider.options,
    name: props.selectDataProvider.id,
    defaultValue: currentNodeJson.range || ''
  }), props.children), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__panel__box"
  }, props.showCardinality && /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    help: "card_min",
    defaultValue: currentNodeJson.min || '',
    name: "min",
    title: _detailsLabels.CARDINALITY_MIN_TITLE,
    onBlur: changePropertyValue
  }), /*#__PURE__*/_react["default"].createElement(_BaseInputElement.BaseInputElement, {
    help: "card_max",
    defaultValue: currentNodeJson.max || '',
    name: "max",
    title: _detailsLabels.CARDINALITY_MAX_TITLE,
    onBlur: changePropertyValue
  }))));
};

exports.BasePropertyComponent = BasePropertyComponent;
BasePropertyComponent.propTypes = {
  showCardinality: _propTypes["default"].bool
};
BasePropertyComponent.defaultProps = {
  showCardinality: true
};