"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ModelMainHeaderComponent = void 0;

var _react = _interopRequireDefault(require("react"));

var _ToogleButton = require("./ToogleButton");

var _detailsLabels = require("../../constants/details-labels");

var _actionType = require("../utils/actionType");

var _elementsName = require("../utils/elementsName");

var _graphObjectContext = require("../hook/graphObjectContext");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var ModelMainHeaderComponent = function ModelMainHeaderComponent(props) {
  var _GraphContextObj = (0, _graphObjectContext.GraphContextObj)(),
      setNodeAction = _GraphContextObj.setNodeAction,
      resetTreeModel = _GraphContextObj.resetTreeModel;

  var viewEdit = props.isEditMode === true ? true : false;
  var style = {
    style: {
      visibility: 'hidden'
    }
  };

  if (viewEdit) {
    style = {};
  }

  var setZoomIn = function setZoomIn() {
    props.setZoomEvent({
      type: 'ZOOM_IN',
      'zoom': Date.now()
    });
  };

  var setZoomOut = function setZoomOut() {
    props.setZoomEvent({
      type: 'ZOOM_OUT',
      'zoom': Date.now()
    });
  };

  var setResetView = function setResetView() {
    props.setZoomEvent({
      type: 'RESET_ZOOM',
      'zoom': Date.now()
    });
  };

  var addDocumentType = function addDocumentType() {
    setNodeAction(_actionType.ADD_NEW_ENTITY, _elementsName.CLASS_TYPE_NAME.SCHEMA_ROOT, true);
  };

  var addObjectType = function addObjectType() {
    setNodeAction(_actionType.ADD_NEW_CLASS, _elementsName.CLASS_TYPE_NAME.SCHEMA_ROOT, true);
  };

  var addChoiceType = function addChoiceType() {
    setNodeAction(_actionType.ADD_NEW_CHOICE_CLASS, _elementsName.CLASS_TYPE_NAME.SCHEMA_ROOT, true);
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__hright"
  }, /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: "tdb__model__hright"
  }, style), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__node tdb__model__node--doc"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "custom-img-entities",
    title: "Add ".concat(_elementsName.CLASS_TYPE_NAME_LABEL.DOCUMENT_CLASSES),
    onClick: addDocumentType
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__node tdb__model__node--class"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "custom-img-classes",
    title: "Add ".concat(_elementsName.CLASS_TYPE_NAME_LABEL.OBJECT_CLASSES),
    onClick: addObjectType
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__node tdb__model__node--choice"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "custom-img-choice",
    title: "Add ".concat(_elementsName.CLASS_TYPE_NAME_LABEL.CHOICE_CLASSES),
    onClick: addChoiceType
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__hright"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-search-plus",
    title: _detailsLabels.TOOLBAR_LABELS.ZoomInTooltip,
    onClick: setZoomIn
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-search-minus",
    title: _detailsLabels.TOOLBAR_LABELS.ZoomOutTooltip,
    onClick: setZoomOut
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-circle-notch",
    title: _detailsLabels.TOOLBAR_LABELS.ResetViewPoint,
    onClick: setResetView
  }))), /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: "tdb__model__hright"
  }, style), /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement("i", {
    className: "fa fa-sync",
    title: _detailsLabels.TOOLBAR_LABELS.ResetButtonTooltip,
    onClick: function onClick(e) {
      return window.confirm("If you continue, you'll lose the schema's changes") && resetTreeModel();
    }
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement(_ToogleButton.ToogleButton, {
    baseTooltip: _detailsLabels.TOOLBAR_LABELS.SaveButtonTooltip,
    baseIcon: "fa fa-save",
    selectIcon: "fa fa-save",
    isSelected: false,
    selectClassName: "tdb__button__base tdb__panel__button",
    name: "SAVE_BUTTON",
    onSelectionChange: props.saveData
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "icon-header"
  }, /*#__PURE__*/_react["default"].createElement(_ToogleButton.ToogleButton, {
    onSelectionChange: props.changeMode,
    baseTooltip: _detailsLabels.TOOLBAR_LABELS.EditModeTooltip,
    selectedTooltip: _detailsLabels.TOOLBAR_LABELS.ViewModeTooltip,
    baseIcon: "fa fa-edit",
    selectIcon: "fa fa-edit",
    isSelected: viewEdit
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "tdb__model__iclose"
  }, /*#__PURE__*/_react["default"].createElement(_ToogleButton.ToogleButton, {
    name: "PANEL_OPEN_BUTTON",
    isSelected: props.panelIsOpen,
    baseIcon: "fas fa-sign-in-alt fa-flip-horizontal",
    selectIcon: "fas fa-sign-in-alt",
    onSelectionChange: props.openClosePanel
  })));
};

exports.ModelMainHeaderComponent = ModelMainHeaderComponent;